#include "stdafx.h"

//=========================================================================
// File: judge.cpp
//		XV胋[`
//=========================================================================

#include "judge.h"
#include "GflSHA512.h"
#include "wininet++.h"
using namespace wipp;
using namespace judge;



//-------------------------------------------------------------------------

string PageInfo::genStateString() const
{
	if( status_code < 0 )
		return "Error [Detection]";
	if( status_code / 100 != 2 )
		return "Error ["+lexical_cast<string>(status_code)+"]";
	return last_update->UTCtoLOCAL().toReadableString();
}

//-------------------------------------------------------------------------

string PageInfo::genLinkString() const
{
	string date;
	if( last_update )
	{
		Time t = *last_update;
		date = (format("%02d%02d%04d%02d%02d")
			% t.wDay % t.wMonth % t.wYear % t.wHour % t.wMinute).str();
	}

	string s = link_fmt;
	string::size_type i = 0;
	while( (i=s.find('#')) != string::npos && i+1 != s.size() )
		if( s[i+1]=='u' )
		{
			s.replace(i, 2, url);
			i += url.size();
		}
		else if( s[i+1]=='d' )
		{
			s.replace(i, 2, date);
			i += date.size();
		}
		else
		{
			i += 1;
		}
	return s;
}

//-------------------------------------------------------------------------

tuple<string,string> PageInfo::decompositURL() const
{
	string::size_type p = check.find("//");
	p = (p==string::npos ? 0 : p+2);
	string::size_type q = check.find('/', p);
	string::size_type r = (q==string::npos ? q : q-p);

	return make_tuple(
		check.substr(p,r),
		(q==string::npos ? string("/") : check.substr(q))
	);
}

//-------------------------------------------------------------------------

void Detector::filter( vector<char>* content, const string& s_rexp, const string& e_rexp )
{
	// Ԍ̖0t
	content->push_back('\0');

	// ܂XVm͈͂i
	const char* s = &(*content)[0];
	const char* e = s + content->size() - 1;
	if( !s_rexp.empty() )
	{
		RegEx sr( s_rexp );
		if( sr.Search( s ) )
			s += sr.Position();
	}
	if( !e_rexp.empty() )
	{
		RegEx er( e_rexp );
		if( er.Search( s ) )
			e = s + er.Position() + er.Length();
	}

	// Ƀ^O
	string tmp(s,e);
	tmp = RegEx( "<[^>]*>" ).Merge( tmp, "" );
	vector<char>(tmp.begin(), tmp.end()).swap( *content );
}

//-------------------------------------------------------------------------

bool Detector::check_header( PageInfo& pi, HttpResponse rs )
{
	// Xe[^XR[h`FbN
	pi.status_code = rs.status_code_nothrow();
	if( pi.status_code / 100 != 2 )
	{
		// 304ȂO񂩂ύXȂ
		if( pi.status_code == 304 )
			pi.status_code = 200;
		return true;
	}

	// Last-Modified ΂ƂĎg
	if( optional<Time> lm = rs.last_modified_nothrow() )
	{
		pi.last_update = lm;
		return true;
	}

	return false;
}

//-------------------------------------------------------------------------

void Detector::judgement_one( Agent ag, PageInfo& pi )
{
	string servername, rsrcname;
	tie(servername, rsrcname) = pi.decompositURL();

	if(!servername.empty() && !rsrcname.empty())
	try
	{
		//
		// T[o֐ڑB\ȂIMStB
		//
		Session ss = ag.connectTo( servername.c_str() );
		Session::Headers hdr;
		if( pi.last_update )
			hdr["If-Modified-Since"] = (*pi.last_update).toRFC1123String();

		//
		// HEAD𓊂Ă݂
		//
		HttpResponse rs = ss.httpHEAD( rsrcname.c_str(), hdr );
		if( check_header(pi, rs) )
			return;

		//
		// ߂GET𓊂Ă݂
		//
		rs = ss.httpGET( rsrcname.c_str(), hdr );
		if( check_header(pi, rs) )
			return;

		//
		// eSHA512vZĔr
		//
		vector<char> content = rs.readWhole_nothrow();
		filter( &content, pi.begin_rexp, pi.end_rexp );
		string new_digest = calc_sha512( content );
		if( new_digest != pi.digest )
		{
			pi.last_update = optional<Time>( Time() ); // ݎ
			pi.digest      = new_digest;
		}
	}
	catch(const wipp::wipp_exception&)
	{
		pi.status_code = -1;
	}
}

//-------------------------------------------------------------------------

void Detector::judgement( vector<PageInfo>& infolist )
{
	// Ƃ肠ey[WɔBT[oɂ܂Ƃ߂Ƃ񏈗Ƃ͕ۗ
	Agent ag("Athena Antenna System");
	for_each( infolist.begin(), infolist.end(),
		bind(&Detector::judgement_one, this, ag, _1) );
}
