#include "stdafx.h"

//=========================================================================
// File: parser.cpp
//		y[W`t@C͂镔łB
//=========================================================================

#include "parser.h"
namespace parser {
using namespace boost::spirit;
using judge::PageInfo;



//-------------------------------------------------------------------------
// Class: my_grammar
//-------------------------------------------------------------------------

struct my_grammar
	: public grammar<my_grammar>
{
	//----------
	// @`
	//----------
	template<typename ScannerT>
	struct definition
	{
		definition(const my_grammar& self)
		{
			#define ACT(f)    bind(&my_grammar::f, self, _1, _2)
			#define ACT2(f,p) bind(&my_grammar::f, self, &PageInfo::p, _1, _2)

			/////////////////////////////////////////////////////////////////
			START = *(global_def | (begin>>*local_def>>end));

			begin = hr >> eol_p                            [ACT(begin)];
			end   = hr >> eol_p                            [ACT(end)];

			def =( "name:"        >> *blank_p >> no_eols   [ACT2(set_to, name)]
			     | "tag:"         >> *blank_p >> no_eols   [ACT2(set_to, tag)]
			     | "url:"         >> *blank_p >> no_eols   [ACT2(set_to, url)]
			     | "check:"       >> *blank_p >> no_eols   [ACT2(set_to, check)]
			     | "begin:"       >> *blank_p >> no_eols   [ACT2(set_to, begin_rexp)]
			     | "end:"         >> *blank_p >> no_eols   [ACT2(set_to, end_rexp)]
			     | "link-format:" >> *blank_p >> no_eols   [ACT2(set_to, link_fmt)]
                 | epsilon_p ) >> eol_p;

			global_def = def;

			 local_def = def
			     | "comment:" >> *blank_p >> (+((no_eols-hr) >> eol_p))
			                                               [ACT2(set_to, comment)];

			hr      = "===" >> *ch_p('=');
			no_eols = *(anychar_p - eol_p);
			/////////////////////////////////////////////////////////////////

			#undef ACT
			#undef ACT2
		}
		const rule<ScannerT>& start() { return START; }

		rule<ScannerT> no_eols, hr;
		rule<ScannerT> START, begin, end, def, global_def, local_def;
	};

	//------------------------------
	// Z}eBbNANV`
	//------------------------------
	struct action
	{
	public:
		action( const PageInfo& default_def )
			: prototype( default_def )
			, operand  ( &prototype ) {}

		const vector<PageInfo>& infolist() const { return datas; }

	public:
		void begin()
		{
			datas.push_back( prototype );
			operand = &datas.back();
		}
		void end()
		{
			operand = &prototype;
		}
		void set_to( string PageInfo::*mem, file_iterator<> i, file_iterator<> e )
		{
			(operand->*mem).assign(i,e);
		}

	private:
		vector<PageInfo> datas;
		PageInfo         prototype;
		PageInfo*        operand;
	};

	// ]
	void begin( file_iterator<>, file_iterator<> ) const
		{ actor.begin(); }
	void end( file_iterator<>, file_iterator<> ) const
		{ actor.end(); }
	void set_to( string PageInfo::*mem, file_iterator<> i, file_iterator<> e ) const
		{ actor.set_to( mem, i , e ); }

	//------
	// \z
	//------
	my_grammar( action& actor )
		: actor( actor ) {}
	action& actor;
};



//-------------------------------------------------------------------------
// Function: parse
//-------------------------------------------------------------------------

vector<PageInfo> parse( const char* filename )
{
	// t@CJ
	file_iterator<> fst(filename);
	if( !fst )
		throw parser_exception("could not open file");
	file_iterator<> lst = fst.make_end();

	// p[U
	PageInfo p;
	p.name     = "noname";
	p.link_fmt = "#u";
	my_grammar::action ac(p);

	// 
	if( !parse(fst,lst,my_grammar(ac)).full )
		throw parser_exception("parsing failed");

	// ʂԂ
	return ac.infolist();
}

//=========================================================================
} // namespace end
