#pragma once

//=========================================================================
// Package: athena::wininet++
//		httpṕAWinInetAPI ̂ɂ܂ȂbpB
//
//	Proxy̎wƂ񓯊ʐMƂʓ|ȕ͂܂̂ƂiVŁB
//=========================================================================

namespace wipp {

class Session;
class HttpResponse;



//-------------------------------------------------------------------------
// Class: wipp_exception
//		wininet++Cu̔O
//-------------------------------------------------------------------------

class wipp_exception
	: public runtime_error
{
public:
	// Function: wipp_exception
	wipp_exception(const string& message)
		: runtime_error(message) {}
};



//-------------------------------------------------------------------------
// Struct: handle_internet
//		nh^HINTERNET̃bp
//
//	悻̏HINTERNET <klx::smart_constant> łB
//-------------------------------------------------------------------------

struct handle_internet
	: public klx::smart_constant<HINTERNET>
{
public:
	// Function: handle_internet
	//		nhlō\z
	handle_internet() {}

	// Function: handle_internet
	//		w肵HINTENETǗIuWFNg\z
	explicit handle_internet( HINTERNET h )
		: klx::smart_constant<HINTERNET>( h, &handle_internet::close ) {}

	// Function: operator bool
	//		LnhȂtrue
	operator bool() const { return (**this != 0); }

	// Function: operator!
	//		nhȂtrue
	bool operator!() const { return (**this == 0); }

private:
	operator int() const;
	static void close( HINTERNET h ) { if(h) ::InternetCloseHandle( h ); }
};



//-------------------------------------------------------------------------
// Class: Time
//		ȈՎǗ
//
//	- wYear
//	- wMonth
//	- wDayOfWeek (0:j, 1:j, ...)
//	- wDay
//	- wHour
//	- wMinute
//	- wSecond
//	- wMilliseconds
//-------------------------------------------------------------------------

class Time
	: public SYSTEMTIME
	, boost::less_than_comparable1< Time
	, boost::less_than_comparable2< Time, SYSTEMTIME
	, boost::equality_comparable1 < Time
	, boost::equality_comparable2 < Time, SYSTEMTIME
	> > > >
{
public:
	// Function: Time
	//		UTČݎō\z
	Time();

	// Function: Time
	//		w̎Ԃō\z
	Time(const SYSTEMTIME& s) : SYSTEMTIME(s) {}

	// Function: toReadableString
	//		eĂƁ[ɐďo
	string toReadableString() const;

	// Function: toRFC1123String
	//		eUTCƂ݂ȂARFC1123ɏ]֕ϊ
	string toRFC1123String() const;

	// Function: UTCtoLOCAL
	//		UTCVXěn֕ϊ
	Time UTCtoLOCAL() const;

	// Function: LOCALtoUTC
	//		VXěnUTC֕ϊ
	Time LOCALtoUTC() const;

	// Function: operator<
	//		rBÂ''ȂB
	bool operator<(const Time& rhs) const;
	bool operator<(const SYSTEMTIME& rhs) const { return *this<(Time(rhs)); }

	// Function: operator==
	//		lrB
	bool operator==(const Time& rhs) const;
	bool operator==(const SYSTEMTIME& rhs) const { return *this==(Time(rhs)); }
};

// Function: operator<<
//		Xg[ւ̏o
ostream& operator<<( ostream& os, const Time& time );

// Function: operator>>
//		Xg[̓
istream& operator>>( istream& is, Time& time );



//-------------------------------------------------------------------------
// Class: Agent
//		OtG[WFgIuWFNg
//-------------------------------------------------------------------------

class Agent
{
public:
	// Function: Agent
	//		Ow肵agent\z
	Agent( const char* name = "wininet++ lib" );

	// Function: connectTo
	//		T[o֐ڑăZbVJn
	//
	// Parameters:
	//		servername - T[o
	//		port       - |[gԍ
	//		serviece   - T[rX̎(INTERNET_SERVICE_FTP etc)
	Session connectTo(
		const char*   servername,
	    INTERNET_PORT port    = INTERNET_DEFAULT_HTTP_PORT,
		int           service = INTERNET_SERVICE_HTTP );

public:
	HINTERNET getTemporaryHandle() const { return *han; }

private:
	handle_internet han;
};



//-------------------------------------------------------------------------
// Class: Session
//		T[oƂ̐ڑ
//-------------------------------------------------------------------------

class Session
{
private:
	friend class Agent;
	Session( const Agent&  agent,
	         const char*   servername,
	         INTERNET_PORT port,
			 int           service );

public:
	// Typedef: Headers
	//		ǉwb_̌^
	typedef map<string, string> Headers;

	// Function: httpHEAD
	//		HEADNGXg𑗐M܂B
	HttpResponse httpHEAD(
		const char*    rsrcname,
		const Headers& additional = Headers() );

	// Function: httpGET
	//		GETNGXg𑗐M܂B
	HttpResponse httpGET(
		const char*    rsrcname,
		const Headers& additional = Headers() );

public:
	// Function: setTimeOut
	//		^CAEgԐݒBftHg20b
	void setTimeOut(double sec);

public:
	HINTERNET getTemporaryHandle() const { return *han; }

private:
	Agent           agent;
	handle_internet han;
	string          servername;

	HttpResponse makeHttpReq( const char* typ, const char* rsrc, const Headers& hdr );
};



//-------------------------------------------------------------------------
// Class: HttpResponse
//		MHTTPv̌ʊǗ
//-------------------------------------------------------------------------

class HttpResponse
{
private:
	friend class Session;
	HttpResponse( const Session& session, handle_internet han );

public:
	// Function: status_code
	//		ʃR[h
	//
	// Returns:
	//	<http://msdn.microsoft.com/library/default.asp?url=/library/en-us/wininet/wininet/http_status_codes.asp>
	int status_code();
	int status_code_nothrow();

	// Function: content_length
	//		f[^{̃̕TCY
	ulong content_length();
	optional<ulong> content_length_nothrow();

	// Function: last_modified
	//		ŏIXVwb_̏
	Time last_modified();
	optional<Time> last_modified_nothrow();

	// Function: query
	//		̑̃wb_
	//
	// Parameters:
	//	flag - <http://msdn.microsoft.com/library/default.asp?url=/library/en-us/wininet/wininet/query_info_flags.asp>
	string query( DWORD flag );
	optional<string> query_nothrow( DWORD flag );

	// Function: readWhole
	//		ԐMĂf[^{̑S
	vector<char> readWhole();
	vector<char> readWhole_nothrow();

public:
	HINTERNET getTemporaryHandle() const { return *han; }

private:
	Session         session;
	handle_internet han;

	bool query( DWORD flag, void* buf, DWORD* siz );
};



//=========================================================================
} // namespace end
